import { traverse, getSectionMetadata, shiftSection } from "@webassemblyjs/ast";
import { overrideBytesInBuffer } from "@webassemblyjs/helper-buffer";
export function removeSection(ast, uint8Buffer, section) {
  var sectionMetadata = getSectionMetadata(ast, section);

  if (typeof sectionMetadata === "undefined") {
    throw new Error("Section metadata not found");
  } // replacement is nothing


  var replacement = [];
  var startsIncludingId = sectionMetadata.startOffset - 1;
  var ends = sectionMetadata.startOffset + sectionMetadata.size.value + 1;
  var delta = -(ends - startsIncludingId);
  /**
   * update AST
   */
  // Once we hit our section every that is after needs to be shifted by the delta

  var encounteredSection = false;
  traverse(ast, {
    SectionMetadata: function SectionMetadata(path) {
      if (path.node.section === section) {
        encounteredSection = true;
        return path.remove();
      }

      if (encounteredSection === true) {
        shiftSection(ast, path.node, delta);
      }
    }
  });
  return overrideBytesInBuffer(uint8Buffer, startsIncludingId, ends, replacement);
}